Index: CKEditor/trunk/_source/plugins/docprops/dialogs/docprops.js
===================================================================
--- CKEditor/trunk/_source/plugins/docprops/dialogs/docprops.js	(revision 6904)
+++ CKEditor/trunk/_source/plugins/docprops/dialogs/docprops.js	(revision 6904)
@@ -0,0 +1,686 @@
+﻿/*
+Copyright (c) 2003-2011, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.dialog.add( 'docProps', function( editor )
+{
+	var lang = editor.lang.docprops,
+		langCommon = editor.lang.common,
+		metaHash = {};
+
+	function getDialogValue( dialogName, callback )
+	{
+		var onOk = function()
+		{
+			releaseHandlers( this );
+			callback( this, this._.parentDialog );
+		};
+		var releaseHandlers = function( dialog )
+		{
+			dialog.removeListener( 'ok', onOk );
+			dialog.removeListener( 'cancel', releaseHandlers );
+		};
+		var bindToDialog = function( dialog )
+		{
+			dialog.on( 'ok', onOk );
+			dialog.on( 'cancel', releaseHandlers );
+		};
+		editor.execCommand( dialogName );
+		if ( editor._.storedDialogs.colordialog )
+			bindToDialog( editor._.storedDialogs.colordialog );
+		else
+		{
+			CKEDITOR.on( 'dialogDefinition', function( e )
+			{
+				if ( e.data.name != dialogName )
+					return;
+
+				var definition = e.data.definition;
+
+				e.removeListener();
+				definition.onLoad = CKEDITOR.tools.override( definition.onLoad, function( orginal )
+				{
+					return function()
+					{
+						bindToDialog( this );
+						definition.onLoad = orginal;
+						if ( typeof orginal == 'function' )
+							orginal.call( this );
+					};
+				});
+			});
+		}
+	}
+	function handleOther()
+	{
+		var dialog = this.getDialog(),
+			other = dialog.getContentElement( 'general', this.id + 'Other' );
+		if ( !other )
+			return;
+		if ( this.getValue() == 'other' )
+		{
+			other.getInputElement().removeAttribute( 'readOnly' );
+			other.focus();
+			other.getElement().removeClass( 'cke_disabled' );
+		}
+		else
+		{
+			other.getInputElement().setAttribute( 'readOnly', true );
+			other.getElement().addClass( 'cke_disabled' );
+		}
+	}
+	function commitMeta( name, isHttp, value )
+	{
+		return function( doc, html, head )
+		{
+			var hash = metaHash,
+				val = typeof value != 'undefined' ? value : this.getValue();
+			if ( !val && ( name in hash ) )
+				hash[ name ].remove();
+			else if ( val && ( name in hash ) )
+				hash[ name ].setAttribute( 'content', val );
+			else if ( val )
+			{
+				var meta = new CKEDITOR.dom.element( 'meta', editor.document );
+				meta.setAttribute( isHttp ? 'http-equiv' : 'name', name );
+				meta.setAttribute( 'content', val );
+				head.append( meta );
+			}
+		};
+	}
+	function setupMeta( name, ret )
+	{
+		return function()
+		{
+			var hash = metaHash,
+				result = ( name in hash ) ? hash[ name ].getAttribute( 'content' ) || '' : '';
+			if ( ret )
+				return result;
+			this.setValue( result );
+			return null;
+		};
+	}
+	function commitMargin( name )
+	{
+		return function( doc, html, head, body )
+		{
+			body.removeAttribute( 'margin' + name );
+			var val = this.getValue();
+			if ( val !== '' )
+				body.setStyle( 'margin-' + name, CKEDITOR.tools.cssLength( val ) );
+			else
+				body.removeStyle( 'margin-' + name );
+		};
+	}
+
+	function createMetaHash( doc )
+	{
+		var hash = {},
+			metas = doc.getElementsByTag( 'meta' ),
+			count = metas.count();
+
+		for ( var i = 0; i < count; i++ )
+		{
+			var meta = metas.getItem( i );
+			hash[ meta.getAttribute( meta.hasAttribute( 'http-equiv' ) ? 'http-equiv' : 'name' ).toLowerCase() ] = meta;
+		}
+		return hash;
+	}
+	// We cannot just remove the style from the element, as it might be affected from non-inline stylesheets.
+	// To get the proper result, we should manually set the inline style to its default value.
+	function resetStyle( element, prop, resetVal )
+	{
+		element.removeStyle( prop );
+		if ( element.getComputedStyle( prop ) != resetVal )
+			element.setStyle( prop, resetVal );
+	}
+
+	// Utilty to shorten the creation of color fields in the dialog.
+	var colorField = function( id, label, fieldProps )
+	{
+		return {
+			type : 'hbox',
+			padding : 0,
+			widths : [ '60%', '40%' ],
+			children : [
+				CKEDITOR.tools.extend( {
+					type : 'text',
+					id : id,
+					label : lang[ label ]
+				}, fieldProps || {}, 1 ),
+				{
+					type : 'button',
+					id : id + 'Choose',
+					label : lang.chooseColor,
+					className : 'colorChooser',
+					onClick : function()
+					{
+						var self = this;
+						getDialogValue( 'colordialog', function( colorDialog )
+						{
+							var dialog = self.getDialog();
+							dialog.getContentElement( dialog._.currentTabId, id ).setValue( colorDialog.getContentElement( 'picker', 'selectedColor' ).getValue() );
+						});
+					}
+				}
+			]
+		};
+	};
+	var previewSrc = 'javascript:' +
+		'void((function(){' +
+			encodeURIComponent(
+				'document.open();' +
+				( CKEDITOR.env.isCustomDomain() ? 'document.domain=\'' + document.domain + '\';' : '' ) +
+				'document.write( \'<html style="background-color: #ffffff; height: 100%"><head></head><body style="width: 100%; height: 100%; margin: 0px">' + lang.previewHtml + '</body></html>\' );' +
+				'document.close();'
+			) +
+		'})())';
+
+	return {
+		title : lang.title,
+		minHeight: 330,
+		minWidth: 500,
+		onShow : function()
+		{
+			var doc = editor.document,
+				html = doc.getElementsByTag( 'html' ).getItem( 0 ),
+				head = doc.getHead(),
+				body = doc.getBody();
+			metaHash = createMetaHash( doc );
+			this.setupContent( doc, html, head, body );
+		},
+		onHide : function()
+		{
+			metaHash = {};
+		},
+		onOk : function()
+		{
+			var doc = editor.document,
+				html = doc.getElementsByTag( 'html' ).getItem( 0 ),
+				head = doc.getHead(),
+				body = doc.getBody();
+			this.commitContent( doc, html, head, body );
+		},
+		contents : [
+			{
+				id : 'general',
+				label : langCommon.generalTab,
+				elements : [
+					{
+						type : 'text',
+						id : 'title',
+						label : lang.docTitle,
+						setup : function( doc )
+						{
+							this.setValue( doc.getElementsByTag( 'title' ).getItem( 0 ).data( 'cke-title' ) );
+						},
+						commit : function( doc, html, head, body, isPreview )
+						{
+							if ( isPreview )
+								return;
+							doc.getElementsByTag( 'title' ).getItem( 0 ).data( 'cke-title', this.getValue() );
+						}
+					},
+					{
+						type : 'hbox',
+						children : [
+							{
+								type : 'select',
+								id : 'dir',
+								label : langCommon.langDir,
+								style : 'width: 100%',
+								items : [
+									[ langCommon.notSet , '' ],
+									[ langCommon.langDirLtr, 'ltr' ],
+									[ langCommon.langDirRtl, 'rtl' ]
+								],
+								setup : function( doc, html, head, body )
+								{
+									this.setValue( body.getDirection() || '' );
+								},
+								commit : function( doc, html, head, body )
+								{
+									var val = this.getValue();
+									if ( val )
+										body.setAttribute( 'dir', val );
+									else
+										body.removeAttribute( 'dir' );
+									body.removeStyle( 'direction' );
+								}
+							},
+							{
+								type : 'text',
+								id : 'langCode',
+								label : langCommon.langCode,
+								setup : function( doc, html )
+								{
+									this.setValue( html.getAttribute( 'xml:lang' ) || html.getAttribute( 'lang' ) || '' );
+								},
+								commit : function( doc, html, head, body, isPreview )
+								{
+									if ( isPreview )
+										return;
+									var val = this.getValue();
+									if ( val )
+										html.setAttributes( { 'xml:lang' : val, lang : val } );
+									else
+										html.removeAttributes( { 'xml:lang' : 1, lang : 1 } );
+								}
+							}
+						]
+					},
+					{
+						type : 'hbox',
+						children : [
+							{
+								type : 'select',
+								id : 'charset',
+								label : lang.charset,
+								style : 'width: 100%',
+								items : [
+									[ langCommon.notSet, '' ],
+									[ lang.charsetASCII, 'us-ascii' ],
+									[ lang.charsetCE, 'iso-8859-2' ],
+									[ lang.charsetCT, 'big5' ],
+									[ lang.charsetCR, 'iso-8859-5' ],
+									[ lang.charsetGR, 'iso-8859-7' ],
+									[ lang.charsetJP, 'iso-2022-jp' ],
+									[ lang.charsetKR, 'iso-2022-kr' ],
+									[ lang.charsetTR, 'iso-8859-9' ],
+									[ lang.charsetUN, 'utf-8' ],
+									[ lang.charsetWE, 'iso-8859-1' ],
+									[ lang.other, 'other' ]
+								],
+								'default' : '',
+								onChange : function()
+								{
+									this.getDialog().selectedCharset = this.getValue() != 'other' ? this.getValue() : '';
+									handleOther.call( this );
+								},
+								setup : function()
+								{
+									this.metaCharset = ( 'charset' in metaHash );
+
+									var func = setupMeta( this.metaCharset ? 'charset' : 'content-type', 1, 1 ),
+										val = func.call( this );
+
+									!this.metaCharset && val.match( /charset=[^=]+$/ ) && ( val = val.substring( val.indexOf( '=' ) + 1 ) );
+
+									if ( val )
+									{
+										this.setValue( val.toLowerCase() );
+										if ( !this.getValue() )
+										{
+											this.setValue( 'other' );
+											var other = this.getDialog().getContentElement( 'general', 'charsetOther' );
+											other && other.setValue( val );
+										}
+										this.getDialog().selectedCharset = val;
+									}
+
+									handleOther.call( this );
+								},
+								commit : function( doc, html, head, body, isPreview )
+								{
+									if ( isPreview )
+										return;
+									var value = this.getValue(),
+										other = this.getDialog().getContentElement( 'general', 'charsetOther' );
+
+									value == 'other' && ( value = other ? other.getValue() : '' );
+
+									value && !this.metaCharset && ( value = ( metaHash[ 'content-type' ] ? metaHash[ 'content-type' ].getAttribute( 'content' ).split( ';' )[0] : 'text/html' ) + '; charset=' + value );
+
+									var func = commitMeta( this.metaCharset ? 'charset' : 'content-type', 1, value );
+									func.call( this, doc, html, head );
+								}
+							},
+							{
+								type : 'text',
+								id : 'charsetOther',
+								label : lang.charsetOther,
+								onChange : function(){ this.getDialog().selectedCharset = this.getValue(); }
+							}
+						]
+					},
+					{
+						type : 'hbox',
+						children : [
+							{
+								type : 'select',
+								id : 'docType',
+								label : lang.docType,
+								style : 'width: 100%',
+								items : [
+									[ langCommon.notSet , '' ],
+									[ 'XHTML 1.1', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">' ],
+									[ 'XHTML 1.0 Transitional', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' ],
+									[ 'XHTML 1.0 Strict', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">' ],
+									[ 'XHTML 1.0 Frameset', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">' ],
+									[ 'HTML 5', '<!DOCTYPE html>' ],
+									[ 'HTML 4.01 Transitional', '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">' ],
+									[ 'HTML 4.01 Strict', '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">' ],
+									[ 'HTML 4.01 Frameset', '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">' ],
+									[ 'HTML 3.2', '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">' ],
+									[ 'HTML 2.0', '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">' ],
+									[ lang.other, 'other' ]
+								],
+								onChange : handleOther,
+								setup : function()
+								{
+									if ( editor.docType )
+									{
+										this.setValue( editor.docType );
+										if ( !this.getValue() )
+										{
+											this.setValue( 'other' );
+											var other = this.getDialog().getContentElement( 'general', 'docTypeOther' );
+											other && other.setValue( editor.docType );
+										}
+									}
+									handleOther.call( this );
+								},
+								commit : function( doc, html, head, body, isPreview )
+								{
+									if ( isPreview )
+										return;
+									var value = this.getValue(),
+										other = this.getDialog().getContentElement( 'general', 'docTypeOther' );
+									editor.docType = value == 'other' ? ( other ? other.getValue() : '' ) : value;
+								}
+							},
+							{
+								type : 'text',
+								id : 'docTypeOther',
+								label : lang.docTypeOther
+							}
+						]
+					},
+					{
+						type : 'checkbox',
+						id : 'xhtmlDec',
+						label : lang.xhtmlDec,
+						setup : function()
+						{
+							this.setValue( !!editor.xmlDeclaration );
+						},
+						commit : function( doc, html, head, body, isPreview )
+						{
+							if ( isPreview )
+								return;
+							if ( this.getValue() )
+							{
+								editor.xmlDeclaration = '<?xml version="1.0" encoding="' + ( this.getDialog().selectedCharset || 'utf-8' )+ '"?>' ;
+								html.setAttribute( 'xmlns', 'http://www.w3.org/1999/xhtml' );
+							}
+							else
+							{
+								editor.xmlDeclaration = '';
+								html.removeAttribute( 'xmlns' );
+							}
+						}
+					}
+				]
+			},
+			{
+				id : 'design',
+				label : lang.design,
+				elements : [
+					{
+						type : 'hbox',
+						widths : [ '60%', '40%' ],
+						children : [
+							{
+								type : 'vbox',
+								children : [
+									colorField( 'txtColor', 'txtColor',
+									{
+										setup : function( doc, html, head, body )
+										{
+											this.setValue( body.getComputedStyle( 'color' ) );
+										},
+										commit : function( doc, html, head, body, isPreview )
+										{
+											if ( this.isChanged() || isPreview )
+											{
+												body.removeAttribute( 'text' );
+												var val = this.getValue();
+												if ( val )
+													body.setStyle( 'color', val );
+												else
+													body.removeStyle( 'color' );
+											}
+										}
+									}),
+									colorField( 'bgColor', 'bgColor', {
+										setup : function( doc, html, head, body )
+										{
+											var val = body.getComputedStyle( 'background-color' ) || '';
+											this.setValue( val == 'transparent' ? '' : val );
+										},
+										commit : function( doc, html, head, body, isPreview )
+										{
+											if ( this.isChanged() || isPreview )
+											{
+												body.removeAttribute( 'bgcolor' );
+												var val = this.getValue();
+												if ( val )
+													body.setStyle( 'background-color', val );
+												else
+													resetStyle( body, 'background-color', 'transparent' );
+											}
+										}
+									}),
+									{
+										type : 'hbox',
+										widths : [ '60%', '40%' ],
+										padding : 0,
+										children : [
+											{
+												type : 'text',
+												id : 'bgImage',
+												label : lang.bgImage,
+												setup : function( doc, html, head, body )
+												{
+													var val = body.getComputedStyle( 'background-image' ) || '';
+													if ( val == 'none' )
+														val = '';
+													else
+													{
+														val = val.replace( /url\(\s*(["']?)\s*([^\)]*)\s*\1\s*\)/i, function( match, quote, url )
+														{
+															return url;
+														});
+													}
+													this.setValue( val );
+												},
+												commit : function( doc, html, head, body )
+												{
+													body.removeAttribute( 'background' );
+													var val = this.getValue();
+													if ( val )
+														body.setStyle( 'background-image', 'url(' + val + ')' );
+													else
+														resetStyle( body, 'background-image', 'none' );
+												}
+											},
+											{
+												type : 'button',
+												id : 'bgImageChoose',
+												label : langCommon.browseServer,
+												style : 'display:inline-block;margin-top:10px;',
+												hidden : true,
+												filebrowser : 'bg:bgImage'
+											}
+										]
+									},
+									{
+										type : 'checkbox',
+										id : 'bgFixed',
+										label : lang.bgFixed,
+										setup : function( doc, html, head, body )
+										{
+											this.setValue( body.getComputedStyle( 'background-attachment' ) == 'fixed' );
+										},
+										commit : function( doc, html, head, body )
+										{
+											if ( this.getValue() )
+												body.setStyle( 'background-attachment', 'fixed' );
+											else
+												resetStyle( body, 'background-attachment', 'scroll' );
+										}
+									}
+								]
+							},
+							{
+								type : 'vbox',
+								children : [
+									{
+										type : 'html',
+										id : 'marginTitle',
+										html : '<div style="text-align: center; margin: 0px auto; font-weight: bold">' + lang.margin + '</div>'
+									},
+									{
+										type : 'text',
+										id : 'marginTop',
+										label : lang.marginTop,
+										style : 'width: 80px; text-align: center; margin: 0px auto',
+										controlStyle : 'text-align: center',
+										setup : function( doc, html, head, body )
+										{
+											this.setValue( body.getStyle( 'margin-top' ) || body.getAttribute( 'margintop' ) || '' );
+										},
+										commit : commitMargin( 'top' ),
+										onLoad : function()
+										{
+											this.getElement().getParent().setStyle( 'text-align', 'center' );
+										}
+									},
+									{
+										type : 'hbox',
+										children : [
+											{
+												type : 'text',
+												id : 'marginLeft',
+												label : lang.marginLeft,
+												style : 'width: 80px; text-align: center; margin: 0px auto',
+												controlStyle : 'text-align: center',
+												setup : function( doc, html, head, body )
+												{
+													this.setValue( body.getStyle( 'margin-left' ) || body.getAttribute( 'marginleft' ) || '' );
+												},
+												commit : commitMargin( 'left' ),
+												onLoad : function()
+												{
+													this.getElement().getParent().setStyle( 'text-align', 'center' );
+												}
+											},
+											{
+												type : 'text',
+												id : 'marginRight',
+												label : lang.marginRight,
+												style : 'width: 80px; text-align: center; margin: 0px auto',
+												controlStyle : 'text-align: center',
+												setup : function( doc, html, head, body )
+												{
+													this.setValue( body.getStyle( 'margin-right' ) || body.getAttribute( 'marginright' ) || '' );
+												},
+												commit : commitMargin( 'right' ),
+												onLoad : function()
+												{
+													this.getElement().getParent().setStyle( 'text-align', 'center' );
+												}
+											}
+										]
+									},
+									{
+										type : 'text',
+										id : 'marginBottom',
+										label : lang.marginBottom,
+										style : 'width: 80px; text-align: center; margin: 0px auto',
+										controlStyle : 'text-align: center',
+										setup : function( doc, html, head, body )
+										{
+											this.setValue( body.getStyle( 'margin-bottom' ) || body.getAttribute( 'marginbottom' ) || '' );
+										},
+										commit : commitMargin( 'bottom' ),
+										onLoad : function()
+										{
+											this.getElement().getParent().setStyle( 'text-align', 'center' );
+										}
+									}
+								]
+							}
+						]
+					}
+				]
+			},
+			{
+				id : 'meta',
+				label : lang.meta,
+				elements : [
+					{
+						type : 'textarea',
+						id : 'metaKeywords',
+						label : lang.metaKeywords,
+						setup : setupMeta( 'keywords' ),
+						commit : commitMeta( 'keywords' )
+					},
+					{
+						type : 'textarea',
+						id : 'metaDescription',
+						label : lang.metaDescription,
+						setup : setupMeta( 'description' ),
+						commit : commitMeta( 'description' )
+					},
+					{
+						type : 'text',
+						id : 'metaAuthor',
+						label : lang.metaAuthor,
+						setup : setupMeta( 'author' ),
+						commit : commitMeta( 'author' )
+					},
+					{
+						type : 'text',
+						id : 'metaCopyright',
+						label : lang.metaCopyright,
+						setup : setupMeta( 'copyright' ),
+						commit : commitMeta( 'copyright' )
+					}
+				]
+			},
+			{
+				id : 'preview',
+				label : langCommon.preview,
+				elements : [
+					{
+						type : 'html',
+						id : 'previewHtml',
+						html : '<iframe src="' + previewSrc + '" style="width: 100%; height: 310px" hidefocus="true" frameborder="0" ' +
+								'id="cke_docProps_preview_iframe"></iframe>',
+						onLoad : function()
+						{
+							this.getDialog().on( 'selectPage', function( ev )
+							{
+								if ( ev.data.page == 'preview' )
+								{
+									var self = this;
+									setTimeout( function()
+									{
+										var doc = CKEDITOR.document.getById( 'cke_docProps_preview_iframe' ).getFrameDocument(),
+											html = doc.getElementsByTag( 'html' ).getItem( 0 ),
+											head = doc.getHead(),
+											body = doc.getBody();
+										self.commitContent( doc, html, head, body, 1 );
+									}, 50 );
+								}
+							});
+							CKEDITOR.document.getById( 'cke_docProps_preview_iframe' ).getAscendant( 'table' ).setStyle( 'height', '100%' );
+						}
+					}
+				]
+			}
+		]
+	};
+});
Index: CKEditor/trunk/_source/plugins/docprops/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/docprops/plugin.js	(revision 6904)
+++ CKEditor/trunk/_source/plugins/docprops/plugin.js	(revision 6904)
@@ -0,0 +1,22 @@
+﻿/*
+Copyright (c) 2003-2011, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.plugins.add( 'docprops',
+{
+	init : function( editor )
+	{
+		var cmd = new CKEDITOR.dialogCommand( 'docProps' );
+		// Only applicable on full page mode.
+		cmd.modes = { wysiwyg : editor.config.fullPage };
+		editor.addCommand( 'docProps', cmd );
+		CKEDITOR.dialog.add( 'docProps', this.path + 'dialogs/docprops.js' );
+
+		editor.ui.addButton( 'DocProps',
+		{
+			label : editor.lang.docprops.label,
+			command : 'docProps'
+		});
+	}
+});
Index: CKEditor/trunk/_source/plugins/editingblock/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/editingblock/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/editingblock/plugin.js	(revision 6904)
@@ -11,9 +11,4 @@
 (function()
 {
-	var getMode = function( editor, mode )
-	{
-		return editor._.modes && editor._.modes[ mode || editor.mode ];
-	};
-
 	// This is a semaphore used to avoid recursive calls between
 	// the following data handling functions.
@@ -50,5 +45,5 @@
 						{
 							isHandlingData = true;
-							getMode( editor ).loadData( editor.getData() );
+							editor.getMode().loadData( editor.getData() );
 							isHandlingData = false;
 						}
@@ -60,6 +55,9 @@
 							editor.on( 'mode', function()
 								{
-									setData();
-									editor.removeListener( 'mode', arguments.callee );
+									if ( editor.mode )
+									{
+										setData();
+										editor.removeListener( 'mode', arguments.callee );
+									}
 								});
 						}
@@ -72,5 +70,5 @@
 					{
 						isHandlingData = true;
-						editor.setData( getMode( editor ).getData(), null, 1 );
+						editor.setData( editor.getMode().getData(), null, 1 );
 						isHandlingData = false;
 					}
@@ -80,5 +78,5 @@
 				{
 					if ( editor.mode )
-						event.data = getMode( editor ).getSnapshotData();
+						event.data = editor.getMode().getSnapshotData();
 				});
 
@@ -86,5 +84,5 @@
 				{
 					if ( editor.mode )
-						getMode( editor ).loadSnapshotData( event.data );
+						editor.getMode().loadSnapshotData( event.data );
 				});
 
@@ -168,5 +166,5 @@
 			this.fire( 'beforeModeUnload' );
 
-			var currentMode = getMode( this );
+			var currentMode = this.getMode();
 			data = currentMode.getData();
 			currentMode.unload( holderElement );
@@ -177,5 +175,5 @@
 
 		// Load required mode.
-		var modeEditor = getMode( this, mode );
+		var modeEditor = this.getMode( mode );
 		if ( !modeEditor )
 			throw '[CKEDITOR.editor.setMode] Unknown mode "' + mode + '".';
@@ -194,4 +192,15 @@
 
 	/**
+	 * Gets the current or any of the objects that represent the editing
+	 * area modes. The two most common editing modes are "wysiwyg" and "source".
+	 * @param {String} [mode] The mode to be retrieved. If not specified, the
+	 *		current one is returned.
+	 */
+	CKEDITOR.editor.prototype.getMode = function( mode )
+	{
+		return this._.modes && this._.modes[ mode || this.mode ];
+	};
+
+	/**
 	 * Moves the selection focus to the editing are space in the editor.
 	 */
@@ -199,5 +208,5 @@
 	{
 		this.forceNextSelectionCheck();
-		var mode = getMode( this );
+		var mode = this.getMode();
 		if ( mode )
 			mode.focus();
Index: CKEditor/trunk/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/elementspath/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/elementspath/plugin.js	(revision 6904)
@@ -16,4 +16,5 @@
 		{
 			editorFocus : false,
+			readOnly : 1,
 			exec : function( editor )
 			{
@@ -125,12 +126,23 @@
 					while ( element )
 					{
-						var ignore = 0;
+						var ignore = 0,
+							name;
+
+						if ( element.data( 'cke-display-name' ) )
+							name = element.data( 'cke-display-name' );
+						else if ( element.data( 'cke-real-element-type' ) )
+							name = element.data( 'cke-real-element-type' );
+						else
+							name = element.getName();
+
 						for ( var i = 0; i < filters.length; i++ )
 						{
-							if ( filters[ i ]( element ) === false )
+							var ret = filters[ i ]( element, name );
+							if ( ret === false )
 							{
 								ignore = 1;
 								break;
 							}
+							name = ret || name;
 						}
 
@@ -138,9 +150,4 @@
 						{
 							var index = elementsList.push( element ) - 1;
-							var name;
-							if ( element.data( 'cke-real-element-type' ) )
-								name = element.data( 'cke-real-element-type' );
-							else
-								name = element.getName();
 
 							// Use this variable to add conditional stuff to the
@@ -190,10 +197,12 @@
 				});
 
-			editor.on( 'contentDomUnload', function()
-				{
-					// If the spaceElement hasn't been initialized, don't try to do it at this time
-					// Only reuse existing reference.
-					spaceElement && spaceElement.setHtml( emptyHtml );
-				});
+			function empty()
+			{
+				spaceElement && spaceElement.setHtml( emptyHtml );
+				delete editor._.elementsPath.list;
+			}
+
+			editor.on( 'readOnly', empty );
+			editor.on( 'contentDomUnload', empty );
 
 			editor.addCommand( 'elementsPathFocus', commands.toolbarFocus );
Index: CKEditor/trunk/_source/plugins/enterkey/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/enterkey/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/enterkey/plugin.js	(revision 6904)
@@ -12,7 +12,19 @@
 		init : function( editor )
 		{
-			var specialKeys = editor.specialKeys;
-			specialKeys[ 13 ] = enter;
-			specialKeys[ CKEDITOR.SHIFT + 13 ] = shiftEnter;
+			editor.addCommand( 'enter', {
+				modes : { wysiwyg:1 },
+				editorFocus : false,
+				exec : function( editor ){ enter( editor ); }
+			});
+
+			editor.addCommand( 'shiftEnter', {
+				modes : { wysiwyg:1 },
+				editorFocus : false,
+				exec : function( editor ){ shiftEnter( editor ); }
+			});
+
+			var keystrokes = editor.keystrokeHandler.keystrokes;
+			keystrokes[ 13 ] = 'enter';
+			keystrokes[ CKEDITOR.SHIFT + 13 ] = 'shiftEnter';
 		}
 	});
@@ -32,10 +44,12 @@
 			var doc = range.document;
 
+			var atBlockStart = range.checkStartOfBlock(),
+				atBlockEnd = range.checkEndOfBlock(),
+				path = new CKEDITOR.dom.elementPath( range.startContainer ),
+				block = path.block;
+
 			// Exit the list when we're inside an empty list item block. (#5376)
-			if ( range.checkStartOfBlock() && range.checkEndOfBlock() )
-			{
-				var path = new CKEDITOR.dom.elementPath( range.startContainer ),
-						block = path.block;
-
+			if ( atBlockStart && atBlockEnd )
+			{
 				if ( block && ( block.is( 'li' ) || block.getParent().is( 'li' ) ) )
 				{
@@ -44,4 +58,7 @@
 				}
 			}
+			// Don't split <pre> if we're in the middle of it, act as shift enter key.
+			else if ( !atBlockEnd && block && block.is( 'pre' ) )
+				enterBr( editor, mode, range, forceMode );
 
 			// Determine the block element to be used.
@@ -108,5 +125,6 @@
 					// a Shift+Enter (#77). Create a new block element instead
 					// (later in the code).
-					if ( previousBlock.is( 'li' ) || !headerTagRegex.test( previousBlock.getName() ) )
+					if ( previousBlock.is( 'li' ) ||
+							! ( headerTagRegex.test( previousBlock.getName() ) || previousBlock.is( 'pre' ) ) )
 					{
 						// Otherwise, duplicate the previous block.
@@ -337,12 +355,5 @@
 		// 1. We want to enforce the mode to be respected, instead
 		// of cloning the current block. (#77)
-		// 2. Always perform a block break when inside <pre> (#5402).
-		if ( editor.getSelection().getStartElement().hasAscendant( 'pre', true ) )
-		{
-			setTimeout( function() { enterBlock( editor, editor.config.enterMode, null, true ); }, 0 );
-			return true;
-		}
-		else
-			return enter( editor, editor.config.shiftEnterMode, 1 );
+		return enter( editor, editor.config.shiftEnterMode, 1 );
 	}
 
@@ -362,5 +373,5 @@
 			{
 				editor.fire( 'saveSnapshot' );	// Save undo step.
-				if ( mode == CKEDITOR.ENTER_BR || editor.getSelection().getStartElement().hasAscendant( 'pre', 1 ) )
+				if ( mode == CKEDITOR.ENTER_BR )
 					enterBr( editor, mode, null, forceMode );
 				else
Index: CKEditor/trunk/_source/plugins/entities/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/entities/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/entities/plugin.js	(revision 6904)
@@ -7,5 +7,5 @@
 {
 	// Base HTML entities.
-	var htmlbase = 'nbsp,gt,lt';
+	var htmlbase = 'nbsp,gt,lt,amp';
 
 	var entities =
@@ -62,5 +62,6 @@
 				shy		: '\u00AD',		// IE
 				gt		: '\u003E',		// IE | FF |   --   | Opera
-				lt		: '\u003C'		// IE | FF | Safari | Opera
+				lt		: '\u003C',		// IE | FF | Safari | Opera
+				amp : '\u0026'		// ALL
 			};
 
@@ -114,5 +115,8 @@
 			{
 				// Mandatory HTML base entities.
-				var selectedEntities = htmlbase;
+				var selectedEntities = '';
+
+				if ( config.basicEntities !== false )
+					selectedEntities += htmlbase;
 
 				if ( config.entities )
@@ -131,6 +135,6 @@
 				var entitiesTable = buildTable( selectedEntities );
 
-				// Create the Regex used to find entities in the text.
-				var entitiesRegex = '[' + entitiesTable.regex + ']';
+				// Create the Regex used to find entities in the text, leave it matches nothing if entities are empty.
+				var entitiesRegex = entitiesTable.regex ? '[' + entitiesTable.regex + ']' : 'a^';
 				delete entitiesTable.regex;
 
@@ -171,4 +175,20 @@
 
 /**
+ * Whether to escape HTML preserved entities in text, including:
+ * <ul>
+ * <li>nbsp</li>
+ * <li>gt</li>
+ * <li>lt</li>
+ * <li>amp</li>
+ * </ul>
+ * <strong>Note:</strong> It should not be subjected to change unless you're outputting non-HTML data format like BBCode.
+ * @type Boolean
+ * @default true
+ * @example
+ * config.basicEntities = false;
+ */
+CKEDITOR.config.basicEntities = true;
+
+/**
  * Whether to use HTML entities in the output.
  * @name CKEDITOR.config.entities
